
.global CPU_SR_Save
.global CPU_SR_Restore

.set INT_DISABLED,           0xC0    /* Disable both FIQ and IRQ. */
.set IRQ_DISABLE,            0x40    /* Disable IRQ */
.set FIQ_DISABLE,            0x80    /* Disable FIQ */

.text
.arm

CPU_SR_Save:
        MRS     r0, cpsr
        ORR     r1, r0, #INT_DISABLED        /* Disable interrupts */
        MSR     cpsr_c, r1
        BX      LR                           /* Returns the original CPSR in R0 */

CPU_SR_Restore:
        MSR     CPSR_c, R0                   /* Retore original CPSR */
        BX      LR

.end
